<?xml version="1.0"?>

<st-source>
<time-stamp>From VisualWorks® NonCommercial, 7.3 of December 3, 2004 on November 15, 2005 at 4:02:05 pm</time-stamp>


<name-space>
<name>Gammanym</name>
<environment>CormasNS.Models</environment>
<private>false</private>
<imports>
			private Smalltalk.*
			private CormasNS.Kernel.*
			</imports>
<category>GammanymCategory</category>
<attributes>
<package>Gammanym</package>
</attributes>
</name-space>


<class>
<name>ConferenceCentre</name>
<environment>CormasNS.Models.Gammanym</environment>
<super>CormasNS.Kernel.ObjectLocation</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>conferenceParticipants planning allLabs allDoctors availableFlyers invitedDoctors </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>GammanymCategory</category>
<attributes>
<package>Gammanym</package>
</attributes>
</class>

<shared-variable>
<name>CurrentId</name>
<environment>CormasNS.Models.Gammanym.ConferenceCentre</environment>
<private>false</private>
<constant>false</constant>
<category>As yet unclassified</category>
<attributes>
<package>Gammanym</package>
</attributes>
</shared-variable>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.Gammanym.ConferenceCentre class</class-id> <category>id</category>

<body package="Gammanym" selector="CurrentId">CurrentId
	^CurrentId isNil 
		ifTrue: [0] 
		ifFalse: [CurrentId]</body>

<body package="Gammanym" selector="CurrentId:">CurrentId: x
	^CurrentId := x</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.Gammanym.ConferenceCentre</class-id> <category>init</category>

<body package="Gammanym" selector="initOnCell:">initOnCell: aCell 
	self isMovedTo: aCell.
	self invitedDoctors: OrderedCollection new.
	self planning: #( 8 24 56)  asOrderedCollection.
	self conferenceParticipants: Dictionary new.
	self availableFlyers: 0</body>

<body package="Gammanym" selector="initPlanningRandom">initPlanningRandom
| n |
	self planning: SortedCollection new.
[self planning size &lt; 3] whileTrue: [n := Cormas randomFrom: 4 to: 60.
									(planning includes: n) ifFalse: [planning add: n]].
Dialog warn: (' Planning:', '\', 'conference 1:  ',( self planning at: 1) printString, '\', 'conference 2:  ',( self planning at: 2) printString, '\', 'conference 3:  ',( self planning at: 3) printString) withCRs.</body>
</methods>

<methods>
<class-id>CormasNS.Models.Gammanym.ConferenceCentre</class-id> <category>accessing</category>

<body package="Gammanym" selector="allDoctors">allDoctors
	"Getter accessor without default value "
	^allDoctors</body>

<body package="Gammanym" selector="allDoctors:">allDoctors: anObject 
	allDoctors := anObject</body>

<body package="Gammanym" selector="allLabs">allLabs
	"Getter accessor without default value "
	^allLabs</body>

<body package="Gammanym" selector="allLabs:">allLabs: anObject 
	allLabs := anObject</body>

<body package="Gammanym" selector="availableFlyers">availableFlyers
	"Getter accessor with default value = 0 "
	availableFlyers isNil ifTrue:[availableFlyers := 0]. 
	
	^availableFlyers</body>

<body package="Gammanym" selector="availableFlyers:">availableFlyers: anObject 
	availableFlyers := anObject</body>

<body package="Gammanym" selector="conferenceParticipants">conferenceParticipants
	"Getter accessor without default value "
	^conferenceParticipants</body>

<body package="Gammanym" selector="conferenceParticipants:">conferenceParticipants: anObject 
	conferenceParticipants := anObject</body>

<body package="Gammanym" selector="invitedDoctors">invitedDoctors
	"Getter accessor without default value "
	^invitedDoctors</body>

<body package="Gammanym" selector="invitedDoctors:">invitedDoctors: anObject 
	invitedDoctors := anObject</body>

<body package="Gammanym" selector="planning">planning
	"Getter accessor without default value "
	^planning</body>

<body package="Gammanym" selector="planning:">planning: anObject 
	planning := anObject</body>
</methods>

<methods>
<class-id>CormasNS.Models.Gammanym.ConferenceCentre</class-id> <category>pov</category>

<body package="Gammanym" selector="pov">pov
	"return a symbol or a ColorValue"

	^#conf
	"^ColorValue white"</body>
</methods>

<methods>
<class-id>CormasNS.Models.Gammanym.ConferenceCentre</class-id> <category>control</category>

<body package="Gammanym" selector="updateAttendance:">updateAttendance: aTimeStep 
	(self planning includes: aTimeStep) 
		ifTrue: 
			[self conferenceParticipants at: aTimeStep
				put: (self patch theOccupants at: #Doctor) copy.
			self allLabs 
				do: [:l | l conferenceAttendance: (self conferenceParticipants at: aTimeStep) size]]</body>

<body package="Gammanym" selector="updateConferenceTime:">updateConferenceTime: aTimeStep 
	| aDoctor target |
	(self planning contains: [:c | aTimeStep = c]) ifFalse: [^self].
	target := self allDoctors copy.
	30 timesRepeat: 
			[aDoctor := Cormas selectRandomlyFrom: target.
			self invitedDoctors add: aDoctor.
			aDoctor conferenceInvitation: true.
			target remove: aDoctor].
	self allLabs do: [:l | l conferenceInvitation: true]</body>
</methods>


<class>
<name>Doctor</name>
<environment>CormasNS.Models.Gammanym</environment>
<super>CormasNS.Kernel.AgentCommLocation</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>alert conferenceInvitation counterForFriends counterForHospital dicoContacts drugAdoption dicoFriends flyer memoryAlert practicePatch readiness </inst-vars>
<class-inst-vars>allConferences allHospitals </class-inst-vars>
<imports></imports>
<category>GammanymCategory</category>
<attributes>
<package>Gammanym</package>
</attributes>
</class>

<shared-variable>
<name>CurrentId</name>
<environment>CormasNS.Models.Gammanym.Doctor</environment>
<private>false</private>
<constant>false</constant>
<category>As yet unclassified</category>
<attributes>
<package>Gammanym</package>
</attributes>
</shared-variable>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.Gammanym.Doctor class</class-id> <category>id</category>

<body package="Gammanym" selector="CurrentId">CurrentId
	^CurrentId isNil 
		ifTrue: [0] 
		ifFalse: [CurrentId]</body>

<body package="Gammanym" selector="CurrentId:">CurrentId: x
	^CurrentId := x</body>
</methods>

<methods>
<class-id>CormasNS.Models.Gammanym.Doctor class</class-id> <category>accessing</category>

<body package="Gammanym" selector="allConferences">allConferences
	"Getter accessor without default value "
	^allConferences</body>

<body package="Gammanym" selector="allConferences:">allConferences: anObject 
	allConferences := anObject</body>

<body package="Gammanym" selector="allHospitals">allHospitals
	"Getter accessor without default value "
	^allHospitals</body>

<body package="Gammanym" selector="allHospitals:">allHospitals: anObject 
	allHospitals := anObject</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.Gammanym.Doctor</class-id> <category>init</category>

<body package="Gammanym" selector="initAttributes">initAttributes
	super init.
	self alert: 0.
	self readiness: 4.
	self practicePatch: self patch.
	self drugAdoption: false.
	self conferenceInvitation: false.
	self flyer: false.
	self counterForFriends: (Cormas randomFrom: 0 to: 3).
	self counterForHospital: (Cormas randomFrom: 0 to: 3).
	self memoryAlert: OrderedCollection new</body>

<body package="Gammanym" selector="initMyColleagues">initMyColleagues
	| colleagues |
	self dicoContacts: Dictionary new.
	colleagues := self perceivedSimilarAgentsWithinRange: 0.
	colleagues isEmpty ifTrue: [^self].
	(1 to: colleagues size) 
		do: [:index | self dicoContacts at: (colleagues at: index) id put: 1]</body>

<body package="Gammanym" selector="initMyFriendsWith:">initMyFriendsWith: allDoctors 
	| noOfFriends friend |
	noOfFriends := Cormas randomFrom: 0 to: 3.
	self dicoFriends: Dictionary new.
	noOfFriends timesRepeat: 
			[friend := Cormas selectRandomlyFrom: allDoctors.
			self dicoFriends at: friend id put: 1.
			allDoctors remove: friend]</body>
</methods>

<methods>
<class-id>CormasNS.Models.Gammanym.Doctor</class-id> <category>control</category>

<body package="Gammanym" selector="adoptDrug">adoptDrug
	self drugAdoption = true ifTrue: [^self].
	self readiness = 0 ifTrue: [self drugAdoption: true]</body>

<body package="Gammanym" selector="discussWithFriends:">discussWithFriends: allTheDoctors 
	| collec myFriends meanAdoption |
	self dicoFriends isEmpty ifTrue: [^self].
	self counterForFriends = 4 ifFalse: [^self].
	collec := self dicoFriends keys asOrderedCollection.
	myFriends := allTheDoctors select: [:c | collec includes: c id].
	meanAdoption := (myFriends select: [:c | c drugAdoption = true]) size 
				/ myFriends size.
	meanAdoption &gt;= 0.5 
		ifTrue: 
			[self alert: self alert + 1.
			self memoryAlert add: #friend].
	self updateDico: self dicoFriends with: myFriends</body>

<body package="Gammanym" selector="discussWithOccupants">discussWithOccupants
	| discussionPartners adoptedDoctors |
	discussionPartners := self perceivedSimilarAgentsWithinRange: 0.
	discussionPartners isEmpty ifTrue: [^self].
	self practicePatch = self patch 
		ifFalse: 
			[[discussionPartners size &gt; 5] whileTrue: [discussionPartners removeLast]].
	self updateDico: self dicoContacts with: discussionPartners.
	adoptedDoctors := (discussionPartners select: [:d | d drugAdoption = true]) 
				size / discussionPartners size.
	adoptedDoctors &gt;= 0.5 
		ifTrue: 
			[self alert: self alert + 1.
			self patch = self practicePatch 
				ifTrue: [self memoryAlert add: #colleagues].
			(self patch theOccupants at: #ConferenceCentre) notEmpty 
				ifTrue: [self memoryAlert add: #ConferenceContacts].
			(self patch theOccupants at: #Hospital) notEmpty 
				ifTrue: [self memoryAlert add: #HospitalContacts]]</body>

<body package="Gammanym" selector="getInfoFromLab">getInfoFromLab
	self practicePatch = self patch 
		ifTrue: 
			[self myPractice detailman 
				ifTrue: 
					[self alert: self alert + 1.
					self memoryAlert add: #detailman].
			self myPractice journal 
				ifTrue: 
					[self alert: self alert + 1.
					self memoryAlert add: #journal]].
	self conferenceInvitation = true 
		ifTrue: 
			[self myConference availableFlyers &gt; 0 
				ifTrue: 
					[self flyer: true.
					self alert: self alert + 1.
					self memoryAlert add: #flyer.
					self myConference availableFlyers: self myConference availableFlyers - 1]]</body>

<body package="Gammanym" selector="goToConference">goToConference
	self practicePatch = self patch 
		ifFalse: 
			[self conferenceInvitation: false.
			^self].
	self conferenceInvitation = true 
		ifTrue: 
			[self moveTo: (Cormas selectRandomlyFrom: self class allConferences) patch].</body>

<body package="Gammanym" selector="goToHospital">goToHospital
	self counterForHospital = 4 
		ifTrue: [self moveTo: (Cormas selectRandomlyFrom: self class allHospitals) patch]</body>

<body package="Gammanym" selector="goToPractice">goToPractice
	self practicePatch = self patch ifFalse: [self moveTo: self practicePatch]</body>

<body package="Gammanym" selector="resetAttributes">resetAttributes
	self counterForHospital = 4 
		ifTrue: [self counterForHospital: 0]
		ifFalse: [self counterForHospital: self counterForHospital + 1].
	self counterForFriends = 4 
		ifTrue: [self counterForFriends: 0]
		ifFalse: [self counterForFriends: self counterForFriends + 1].
	self conferenceInvitation: false.
	self flyer: false</body>

<body package="Gammanym" selector="updateDico:with:">updateDico: aDico with: doctors 
	doctors do: 
			[:c | 
			(aDico keys includes: c id) 
				ifTrue: [aDico at: c id put: (aDico at: c id) + 1]
				ifFalse: [aDico at: c id put: 1]]</body>

<body package="Gammanym" selector="updateReadiness">updateReadiness
	self drugAdoption = true ifTrue: [^self].
	self alert &gt;= 1 ifTrue: [self readiness: self readiness - 1].
	self alert: 0</body>
</methods>

<methods>
<class-id>CormasNS.Models.Gammanym.Doctor</class-id> <category>accessing</category>

<body package="Gammanym" selector="alert">alert
	"Getter accessor with default value = 0 "
	alert isNil ifTrue:[alert := 0]. 
	
	^alert</body>

<body package="Gammanym" selector="alert:">alert: anObject 
	alert := anObject</body>

<body package="Gammanym" selector="conferenceInvitation">conferenceInvitation
	"Getter accessor without default value "
	^conferenceInvitation</body>

<body package="Gammanym" selector="conferenceInvitation:">conferenceInvitation: anObject 
	conferenceInvitation := anObject</body>

<body package="Gammanym" selector="counterForFriends">counterForFriends
	"Getter accessor with default value = 0 "
	counterForFriends isNil ifTrue:[counterForFriends := 0]. 
	
	^counterForFriends</body>

<body package="Gammanym" selector="counterForFriends:">counterForFriends: anObject 
	counterForFriends := anObject</body>

<body package="Gammanym" selector="counterForHospital">counterForHospital
	"Getter accessor with default value = 0 "
	counterForHospital isNil ifTrue:[counterForHospital := 0]. 
	
	^counterForHospital</body>

<body package="Gammanym" selector="counterForHospital:">counterForHospital: anObject 
	counterForHospital := anObject</body>

<body package="Gammanym" selector="dicoContacts">dicoContacts
	"Getter accessor without default value "
	^dicoContacts</body>

<body package="Gammanym" selector="dicoContacts:">dicoContacts: anObject 
	dicoContacts := anObject</body>

<body package="Gammanym" selector="dicoFriends">dicoFriends
	"Getter accessor without default value "
	^dicoFriends</body>

<body package="Gammanym" selector="dicoFriends:">dicoFriends: anObject 
	dicoFriends := anObject</body>

<body package="Gammanym" selector="drugAdoption">drugAdoption
	"Getter accessor without default value "
	^drugAdoption</body>

<body package="Gammanym" selector="drugAdoption:">drugAdoption: anObject 
	drugAdoption := anObject</body>

<body package="Gammanym" selector="flyer">flyer
	"Getter accessor without default value "
	^flyer</body>

<body package="Gammanym" selector="flyer:">flyer: anObject 
	flyer := anObject</body>

<body package="Gammanym" selector="memoryAlert">memoryAlert
	"Getter accessor without default value "
	^memoryAlert</body>

<body package="Gammanym" selector="memoryAlert:">memoryAlert: anObject 
	memoryAlert := anObject</body>

<body package="Gammanym" selector="practicePatch">practicePatch
	"Getter accessor without default value "
	^practicePatch</body>

<body package="Gammanym" selector="practicePatch:">practicePatch: anObject 
	practicePatch := anObject</body>

<body package="Gammanym" selector="readiness:">readiness: anObject 
	readiness := anObject</body>
</methods>

<methods>
<class-id>CormasNS.Models.Gammanym.Doctor</class-id> <category>pov</category>

<body package="Gammanym" selector="povAdoption">povAdoption
	self drugAdoption = true ifTrue: [^#adoption] ifFalse: [^#nonAdoption]</body>

<body package="Gammanym" selector="povFriends">povFriends
	self dicoFriends size = 0 ifTrue: [^ColorValue white].
	self dicoFriends size = 1 ifTrue: [^ColorValue yellow].
	self dicoFriends size = 2 ifTrue: [^ColorValue orange].
	self dicoFriends size = 3 ifTrue: [^ColorValue red]</body>

<body package="Gammanym" selector="povPractice">povPractice
	(self practicePatch theOccupants at: #Practice) first practiceType 	= #private 
ifTrue: [^ColorValue cyan].
	(self practicePatch theOccupants at: #Practice) first practiceType 	= #centre 
ifTrue: [^ColorValue darkCyan].
	(self practicePatch theOccupants at: #Practice) first practiceType 	= #clinic 
ifTrue: [^ColorValue blue]</body>
</methods>

<methods>
<class-id>CormasNS.Models.Gammanym.Doctor</class-id> <category>shortcut</category>

<body package="Gammanym" selector="myConference">myConference
	^(self patch theOccupants at: #ConferenceCentre) first</body>

<body package="Gammanym" selector="myPractice">myPractice
	^(self practicePatch theOccupants at: #Practice) first</body>
</methods>

<methods>
<class-id>CormasNS.Models.Gammanym.Doctor</class-id> <category>probes</category>

<body package="Gammanym" selector="readiness">readiness
	"Getter accessor with default value = 4 "
	readiness isNil ifTrue:[readiness := 4]. 
	
	^readiness</body>
</methods>


<class>
<name>Lab</name>
<environment>CormasNS.Models.Gammanym</environment>
<super>CormasNS.Kernel.AgentComm</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>adoptionCurve allDoctors allConferences conferenceInvitation detailman flyer journalRelease maxArticlesJournal memoryVisitedPracticePatch visitedPracticesPatch conferencePatch conferenceAttendance allPractices </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>GammanymCategory</category>
<attributes>
<package>Gammanym</package>
</attributes>
</class>

<shared-variable>
<name>CurrentId</name>
<environment>CormasNS.Models.Gammanym.Lab</environment>
<private>false</private>
<constant>false</constant>
<category>As yet unclassified</category>
<attributes>
<package>Gammanym</package>
</attributes>
</shared-variable>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.Gammanym.Lab class</class-id> <category>id</category>

<body package="Gammanym" selector="CurrentId">CurrentId
	^CurrentId isNil 
		ifTrue: [0] 
		ifFalse: [CurrentId]</body>

<body package="Gammanym" selector="CurrentId:">CurrentId: x
	^CurrentId := x</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.Gammanym.Lab</class-id> <category>init</category>

<body package="Gammanym" selector="init">init
	super init.
	self conferenceInvitation: false.
	self conferenceAttendance: 50.
	self visitedPracticesPatch: OrderedCollection new.
	self memoryVisitedPracticePatch: OrderedCollection new.
	self detailman: 1.
	self flyer: 10.
	self maxArticlesJournal: 2.
	self adoptionCurve: OrderedCollection new.
	self journalRelease: OrderedCollection new</body>
</methods>

<methods>
<class-id>CormasNS.Models.Gammanym.Lab</class-id> <category>control</category>

<body package="Gammanym" selector="calculAdoption">calculAdoption
	| adoptedDoctors |
	adoptedDoctors := (self allDoctors select: [:c | c drugAdoption = true]) 	size.
	self adoptionCurve add: adoptedDoctors</body>

<body package="Gammanym" selector="sendDetailman">sendDetailman
	| availablePractice aTarget |
	self visitedPracticesPatch size = self allPractices size 
		ifTrue: 
			[self memoryVisitedPracticePatch add: self visitedPracticesPatch.
			self visitedPracticesPatch: OrderedCollection new].
	availablePractice := self allPractices select: 
					[:p | 
					(p patch theOccupants at: #Doctor) notEmpty 
						and: [(self visitedPracticesPatch includes: p patch id) = false]].
	availablePractice isEmpty ifTrue: [^self].
	(availablePractice size min: self detailman) timesRepeat: 
			[aTarget := Cormas selectRandomlyFrom: availablePractice.
			aTarget detailman: true.
			self visitedPracticesPatch add: aTarget patch id.
			availablePractice remove: aTarget]</body>

<body package="Gammanym" selector="sendFlyers">sendFlyers
	self conferenceInvitation 
		ifTrue: 
			[self flyer: self conferenceAttendance. 
			self allConferences 
				do: [:f | f availableFlyers: self conferenceAttendance]]</body>

<body package="Gammanym" selector="sendJournals:">sendJournals: aTimeStep 
	| meanAdoption lastIncrement |
	self maxArticlesJournal = 0 ifTrue: [^self].
	aTimeStep &lt; 5 ifTrue: [^self].
	meanAdoption := self adoptionCurve last / aTimeStep.
	lastIncrement := self adoptionCurve last 
				- (self adoptionCurve at: (self adoptionCurve size - 1)).
	lastIncrement &lt; (0.5 * meanAdoption) 
		ifTrue: 
			[self allPractices do: [:j | j journal: true].
			self maxArticlesJournal: self maxArticlesJournal - 1.
			self journalRelease add: aTimeStep]</body>
</methods>

<methods>
<class-id>CormasNS.Models.Gammanym.Lab</class-id> <category>accessing</category>

<body package="Gammanym" selector="adoptionCurve">adoptionCurve
	"Getter accessor without default value "
	^adoptionCurve</body>

<body package="Gammanym" selector="adoptionCurve:">adoptionCurve: anObject 
	adoptionCurve := anObject</body>

<body package="Gammanym" selector="allConferences">allConferences
	"Getter accessor without default value "
	^allConferences</body>

<body package="Gammanym" selector="allConferences:">allConferences: anObject 
	allConferences := anObject</body>

<body package="Gammanym" selector="allDoctors">allDoctors
	"Getter accessor without default value "
	^allDoctors</body>

<body package="Gammanym" selector="allDoctors:">allDoctors: anObject 
	allDoctors := anObject</body>

<body package="Gammanym" selector="allPractices">allPractices
	"Getter accessor without default value "
	^allPractices</body>

<body package="Gammanym" selector="allPractices:">allPractices: anObject 
	allPractices := anObject</body>

<body package="Gammanym" selector="conferenceAttendance">conferenceAttendance
	"Getter accessor with default value = 0 "
	conferenceAttendance isNil ifTrue:[conferenceAttendance := 0]. 
	
	^conferenceAttendance</body>

<body package="Gammanym" selector="conferenceAttendance:">conferenceAttendance: anObject 
	conferenceAttendance := anObject</body>

<body package="Gammanym" selector="conferenceInvitation">conferenceInvitation
	"Getter accessor without default value "
	^conferenceInvitation</body>

<body package="Gammanym" selector="conferenceInvitation:">conferenceInvitation: anObject 
	conferenceInvitation := anObject</body>

<body package="Gammanym" selector="detailman">detailman
	"Getter accessor with default value = 1 "
	detailman isNil ifTrue:[detailman := 1]. 
	
	^detailman</body>

<body package="Gammanym" selector="detailman:">detailman: anObject 
	detailman := anObject</body>

<body package="Gammanym" selector="flyer">flyer
	"Getter accessor with default value = 10 "
	flyer isNil ifTrue:[flyer := 10]. 
	
	^flyer</body>

<body package="Gammanym" selector="flyer:">flyer: anObject 
	flyer := anObject</body>

<body package="Gammanym" selector="journalRelease">journalRelease
	"Getter accessor without default value "
	^journalRelease</body>

<body package="Gammanym" selector="journalRelease:">journalRelease: anObject 
	journalRelease := anObject</body>

<body package="Gammanym" selector="maxArticlesJournal">maxArticlesJournal
	"Getter accessor with default value = 2 "
	maxArticlesJournal isNil ifTrue:[maxArticlesJournal := 2]. 
	
	^maxArticlesJournal</body>

<body package="Gammanym" selector="maxArticlesJournal:">maxArticlesJournal: anObject 
	maxArticlesJournal := anObject</body>

<body package="Gammanym" selector="memoryVisitedPracticePatch">memoryVisitedPracticePatch
	"Getter accessor without default value "
	^memoryVisitedPracticePatch</body>

<body package="Gammanym" selector="memoryVisitedPracticePatch:">memoryVisitedPracticePatch: anObject 
	memoryVisitedPracticePatch := anObject</body>

<body package="Gammanym" selector="visitedPracticesPatch">visitedPracticesPatch
	"Getter accessor without default value "
	^visitedPracticesPatch</body>

<body package="Gammanym" selector="visitedPracticesPatch:">visitedPracticesPatch: anObject 
	visitedPracticesPatch := anObject</body>
</methods>


<class>
<name>JournalRelease</name>
<environment>CormasNS.Models.Gammanym</environment>
<super>UI.SimpleDialog</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>journalDate </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>Cormas-Gammanym</category>
<attributes>
<package>Gammanym</package>
</attributes>
</class>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.Gammanym.JournalRelease class</class-id> <category>interface specs</category>

<body package="Gammanym" selector="windowSpec">windowSpec
	"UIPainter new openOnClass: self andSelector: #windowSpec"

	&lt;resource: #canvas&gt;
	^#(#{UI.FullSpec} 
		#window: 
		#(#{UI.WindowSpec} 
			#label: 'Journal' 
			#bounds: #(#{Graphics.Rectangle} 512 384 735 611 ) ) 
		#component: 
		#(#{UI.SpecCollection} 
			#collection: #(
				#(#{UI.LabelSpec} 
					#layout: #(#{Core.Point} 69 41 ) 
					#name: #Label1 
					#label: 'JournalRelease' ) 
				#(#{UI.TextEditorSpec} 
					#layout: #(#{Graphics.Rectangle} 66 92 168 122 ) 
					#name: #TextEditor1 
					#model: #journalDate 
					#tabRequiresControl: true ) 
				#(#{UI.ActionButtonSpec} 
					#layout: #(#{Graphics.Rectangle} 73 157 154 180 ) 
					#name: #ActionButton1 
					#model: #close 
					#label: 'ok' 
					#defaultable: true ) ) ) )</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.Gammanym.JournalRelease</class-id> <category>aspects</category>

<body package="Gammanym" selector="journalDate">journalDate
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^journalDate isNil
		ifTrue:
			[journalDate := String new asValue]
		ifFalse:
			[journalDate]</body>
</methods>


<class>
<name>Cell</name>
<environment>CormasNS.Models.Gammanym</environment>
<super>CormasNS.Kernel.SpatialEntityElement</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>buildingType </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>GammanymCategory</category>
<attributes>
<package>Gammanym</package>
</attributes>
</class>

<shared-variable>
<name>CurrentId</name>
<environment>CormasNS.Models.Gammanym.Cell</environment>
<private>false</private>
<constant>false</constant>
<category>As yet unclassified</category>
<attributes>
<package>Gammanym</package>
</attributes>
</shared-variable>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.Gammanym.Cell class</class-id> <category>id</category>

<body package="Gammanym" selector="CurrentId">CurrentId
	^CurrentId isNil 
		ifTrue: [0] 
		ifFalse: [CurrentId]</body>

<body package="Gammanym" selector="CurrentId:">CurrentId: x
	^CurrentId := x</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.Gammanym.Cell</class-id> <category>init</category>

<body package="Gammanym" selector="initWith:">initWith: aClass 
	| aNewBuilding |
	aNewBuilding := aClass new.
	aNewBuilding initOnCell: self.
	self buildingType: aNewBuilding.
	^aNewBuilding</body>

<body package="Gammanym" selector="initWith:withType:">initWith: aClass withType: aType 
	| aNewBuilding |
	aNewBuilding := aClass new.
	aNewBuilding initOnCell: self withType: aType.
	self buildingType: aNewBuilding.
	^aNewBuilding</body>
</methods>

<methods>
<class-id>CormasNS.Models.Gammanym.Cell</class-id> <category>accessing</category>

<body package="Gammanym" selector="buildingType">buildingType
	"Getter accessor without default value "
	^buildingType</body>

<body package="Gammanym" selector="buildingType:">buildingType: anObject 
	buildingType := anObject.
 self defineVisualState;
				show</body>
</methods>

<methods>
<class-id>CormasNS.Models.Gammanym.Cell</class-id> <category>display</category>

<body package="Gammanym" selector="displayOn:">displayOn: aGc 
	super displayOn: aGc.
	(self theOccupants at: #Hospital) isEmpty 
		ifFalse: [self displayString: 'Hospital'].
	(self theOccupants at: #ConferenceCentre) isEmpty 
		ifFalse: [self displayString: 'Conference']</body>
</methods>

<methods>
<class-id>CormasNS.Models.Gammanym.Cell</class-id> <category>pov</category>

<body package="Gammanym" selector="povCell">povCell
	(self theOccupants at: #Practice) isEmpty ifTrue: [^ColorValue gray].
	(self theOccupants at: #Practice) first detailman 
		ifTrue: [^ColorValue yellow].
	^ColorValue veryLightGray</body>
</methods>


<class>
<name>InputLab</name>
<environment>CormasNS.Models.Gammanym</environment>
<super>UI.SimpleDialog</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>numberOfJournal numberOfDetailman </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>Cormas-Gammanym</category>
<attributes>
<package>Gammanym</package>
</attributes>
</class>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.Gammanym.InputLab class</class-id> <category>interface specs</category>

<body package="Gammanym" selector="windowSpec">windowSpec
	"UIPainter new openOnClass: self andSelector: #windowSpec"

	&lt;resource: #canvas&gt;
	^#(#{UI.FullSpec} 
		#window: 
		#(#{UI.WindowSpec} 
			#label: 'Lab' 
			#bounds: #(#{Graphics.Rectangle} 627 384 934 584 ) ) 
		#component: 
		#(#{UI.SpecCollection} 
			#collection: #(
				#(#{UI.LabelSpec} 
					#layout: #(#{Core.Point} 25 38 ) 
					#name: #Label1 
					#label: 'Number of Detailman ?' ) 
				#(#{UI.InputFieldSpec} 
					#layout: #(#{Graphics.Rectangle} 65 82 88 106 ) 
					#name: #InputField1 
					#model: #numberOfDetailman 
					#type: #number 
					#formatString: '0' ) 
				#(#{UI.ActionButtonSpec} 
					#layout: #(#{Graphics.Rectangle} 140 150 221 173 ) 
					#name: #ActionButton1 
					#model: #close 
					#label: 'Ok' 
					#defaultable: true ) 
				#(#{UI.LabelSpec} 
					#layout: #(#{Core.Point} 209 39 ) 
					#name: #Label2 
					#label: 'Number of Journal?' ) 
				#(#{UI.InputFieldSpec} 
					#layout: #(#{Graphics.Rectangle} 246 79 273 101 ) 
					#name: #InputField2 
					#model: #numberOfJournal 
					#type: #number 
					#formatString: '0' ) 
				#(#{UI.DividerSpec} 
					#layout: #(#{Graphics.Rectangle} 182 38 186 139 ) 
					#name: #Divider1 
					#orientation: #vertical ) ) ) )</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.Gammanym.InputLab</class-id> <category>aspects</category>

<body package="Gammanym" selector="numberOfDetailman">numberOfDetailman
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^numberOfDetailman isNil
		ifTrue:
			[numberOfDetailman := 0 asValue]
		ifFalse:
			[numberOfDetailman]</body>

<body package="Gammanym" selector="numberOfJournal">numberOfJournal
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^numberOfJournal isNil
		ifTrue:
			[numberOfJournal := 0 asValue]
		ifFalse:
			[numberOfJournal]</body>
</methods>


<class>
<name>Practice</name>
<environment>CormasNS.Models.Gammanym</environment>
<super>CormasNS.Kernel.ObjectLocation</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>detailman journal practiceType </inst-vars>
<class-inst-vars>centre clinic private </class-inst-vars>
<imports></imports>
<category>GammanymCategory</category>
<attributes>
<package>Gammanym</package>
</attributes>
</class>

<shared-variable>
<name>CurrentId</name>
<environment>CormasNS.Models.Gammanym.Practice</environment>
<private>false</private>
<constant>false</constant>
<category>As yet unclassified</category>
<attributes>
<package>Gammanym</package>
</attributes>
</shared-variable>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.Gammanym.Practice class</class-id> <category>id</category>

<body package="Gammanym" selector="CurrentId">CurrentId
	^CurrentId isNil 
		ifTrue: [0] 
		ifFalse: [CurrentId]</body>

<body package="Gammanym" selector="CurrentId:">CurrentId: x
	^CurrentId := x</body>
</methods>

<methods>
<class-id>CormasNS.Models.Gammanym.Practice class</class-id> <category>accessing</category>

<body package="Gammanym" selector="centre">centre
	"Getter accessor without default value "
	^centre</body>

<body package="Gammanym" selector="centre:">centre: anObject 
	centre := anObject</body>

<body package="Gammanym" selector="clinic">clinic
	"Getter accessor without default value "
	^clinic</body>

<body package="Gammanym" selector="clinic:">clinic: anObject 
	clinic := anObject</body>

<body package="Gammanym" selector="private">private
	"Getter accessor without default value "
	^private</body>

<body package="Gammanym" selector="private:">private: anObject 
	private := anObject</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.Gammanym.Practice</class-id> <category>init</category>

<body package="Gammanym" selector="initOnCell:withType:">initOnCell: aCell withType: aType 
	super init.
	self isMovedTo: aCell.
	self practiceType: aType.
	self detailman: false.
	self journal: false</body>
</methods>

<methods>
<class-id>CormasNS.Models.Gammanym.Practice</class-id> <category>accessing</category>

<body package="Gammanym" selector="detailman">detailman
	"Getter accessor without default value "
	^detailman</body>

<body package="Gammanym" selector="detailman:">detailman: anObject 
	detailman := anObject</body>

<body package="Gammanym" selector="journal">journal
	"Getter accessor without default value "
	^journal</body>

<body package="Gammanym" selector="journal:">journal: anObject 
	journal := anObject</body>

<body package="Gammanym" selector="practiceType">practiceType
	"Getter accessor without default value "
	^practiceType</body>

<body package="Gammanym" selector="practiceType:">practiceType: anObject 
	practiceType := anObject</body>
</methods>

<methods>
<class-id>CormasNS.Models.Gammanym.Practice</class-id> <category>pov</category>

<body package="Gammanym" selector="pov">pov
"return a symbol or a ColorValue"
self practiceType = #private ifTrue: [^#private].
self practiceType = #clinic ifTrue: [^#clinic].
self practiceType = #centre ifTrue: [^#centre].
"^ColorValue white"</body>
</methods>

<methods>
<class-id>CormasNS.Models.Gammanym.Practice</class-id> <category>control</category>

<body package="Gammanym" selector="resetAttributes">resetAttributes
	self detailman: false.
	self journal: false</body>
</methods>


<class>
<name>Hospital</name>
<environment>CormasNS.Models.Gammanym</environment>
<super>CormasNS.Kernel.ObjectLocation</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>GammanymCategory</category>
<attributes>
<package>Gammanym</package>
</attributes>
</class>

<shared-variable>
<name>CurrentId</name>
<environment>CormasNS.Models.Gammanym.Hospital</environment>
<private>false</private>
<constant>false</constant>
<category>As yet unclassified</category>
<attributes>
<package>Gammanym</package>
</attributes>
</shared-variable>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.Gammanym.Hospital class</class-id> <category>id</category>

<body package="Gammanym" selector="CurrentId">CurrentId
	^CurrentId isNil 
		ifTrue: [0] 
		ifFalse: [CurrentId]</body>

<body package="Gammanym" selector="CurrentId:">CurrentId: x
	^CurrentId := x</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.Gammanym.Hospital</class-id> <category>init</category>

<body package="Gammanym" selector="initOnCell:">initOnCell: aCell 
	super init.
	self isMovedTo: aCell</body>
</methods>

<methods>
<class-id>CormasNS.Models.Gammanym.Hospital</class-id> <category>pov</category>

<body package="Gammanym" selector="pov">pov
"return a symbol or a ColorValue"
^#hospital
"^ColorValue white"</body>
</methods>


<class>
<name>Gammanym</name>
<environment>CormasNS.Models.Gammanym</environment>
<super>CormasNS.Kernel.CormasModel</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>simulation theCells theDoctors theLabs theHospitals thePractices theConferenceCentres </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>GammanymCategory</category>
<attributes>
<package>Gammanym</package>
</attributes>
</class>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.Gammanym.Gammanym class</class-id> <category>description</category>

<body package="Gammanym" selector="lastUpdate">lastUpdate
^ 'November 15, 2005'	</body>

<body package="Gammanym" selector="version">version
^ 'Cormas_webSite.st'	</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.Gammanym.Gammanym</class-id> <category>instance-creation</category>

<body package="Gammanym" selector="connectAgents">connectAgents
	self theLabs do: 
			[:aLab | 
			aLab allDoctors: self theDoctors.
			aLab allPractices: self thePractices.
			aLab allConferences: self theConferenceCentres].
	self theConferenceCentres do: 
			[:aConferenceCentre | 
			aConferenceCentre allDoctors: self theDoctors.
			aConferenceCentre allLabs: self theLabs].
	Doctor allHospitals: self theHospitals.
	Doctor allConferences: self theConferenceCentres</body>

<body package="Gammanym" selector="initContacts">initContacts
	self theDoctors do: [:c | c initMyFriendsWith: (self otherAgentsButMe: c)].
	self theDoctors do: [:c | c initMyColleagues]</body>

<body package="Gammanym" selector="initDoctors">initDoctors
	| d allDoctors aDoctor |
	super initAgents.
	99 timesRepeat: 
			[d := Doctor new init.
			self theDoctors add: d].
	allDoctors := self theDoctors copy asOrderedCollection.
	self privates do: 
			[:aPrivate | 
			aDoctor := Cormas selectRandomlyFrom: allDoctors.
			aDoctor moveTo: aPrivate patch.
			allDoctors remove: aDoctor].
	self centres do: 
			[:aCentre | 
			3 timesRepeat: 
					[aDoctor := Cormas selectRandomlyFrom: allDoctors.
					aDoctor moveTo: aCentre patch.
					allDoctors remove: aDoctor]].
	self clinics do: 
			[:aClinic | 
			5 timesRepeat: 
					[aDoctor := Cormas selectRandomlyFrom: allDoctors.
					aDoctor moveTo: aClinic patch.
					allDoctors remove: aDoctor]].
	self theDoctors do: [:c | c initAttributes]</body>

<body package="Gammanym" selector="initGrid">initGrid
	| allCells aCell aNewBuilding |
	self theConferenceCentres: OrderedCollection new.
	self theHospitals: OrderedCollection new.
	self thePractices: OrderedCollection new.
	allCells := self theCells copy asOrderedCollection.
	aCell := Cormas selectRandomlyFrom: allCells.
	aNewBuilding := aCell initWith: ConferenceCentre.
	self theConferenceCentres add: aNewBuilding.
	allCells remove: aCell.
	2 timesRepeat: 
			[aCell := Cormas selectRandomlyFrom: allCells.
			aNewBuilding := aCell initWith: Hospital.
			self theHospitals add: aNewBuilding.
			allCells remove: aCell].
	11 timesRepeat: 
			[aCell := Cormas selectRandomlyFrom: allCells.
			aNewBuilding := aCell initWith: Practice withType: #centre.
			self thePractices add: aNewBuilding.
			allCells remove: aCell].
	46 timesRepeat: 
			[aCell := Cormas selectRandomlyFrom: allCells.
			aNewBuilding := aCell initWith: Practice withType: #private.
			self thePractices add: aNewBuilding.
			allCells remove: aCell].
	4 timesRepeat: 
			[aCell := Cormas selectRandomlyFrom: allCells.
			aNewBuilding := aCell initWith: Practice withType: #clinic.
			self thePractices add: aNewBuilding.
			allCells remove: aCell]</body>

<body package="Gammanym" selector="initSimulationDirectory">initSimulationDirectory
	| dataPath1 dataPath2 i tempDir |
	i := 1.
	tempDir := 'simulation' , i printString.
	dataPath1 := (Cormas modelPath: self class name) construct: 'data'.
	dataPath2 := dataPath1 construct: tempDir.
	[dataPath2 asFilename exists] whileTrue: 
			[i := i + 1.
			tempDir := 'simulation' , i printString.
			dataPath2 := dataPath1 construct: tempDir].
	dataPath2 asFilename makeDirectory.
	self simulation: tempDir</body>
</methods>

<methods>
<class-id>CormasNS.Models.Gammanym.Gammanym</class-id> <category>init</category>

<body package="Gammanym" selector="initWithTwoColleagues">initWithTwoColleagues
	super init.
	self initData.
	self initObjects.
	self spaceModel 
		initializeRegularX: 8
		Y: 8
		shape: #squared
		nbNeighbours: #eight
		boundaries: #closed
		delimiter: true.
	self initGrid.
	self initDoctors.
	self initContacts.
	self inputWithTwoColleagues.
	self inputLab.
	self connectAgents.
	self initSimulationDirectory.
	self exportMatrixColleagues.
	self exportMatrixFriends</body>
</methods>

<methods>
<class-id>CormasNS.Models.Gammanym.Gammanym</class-id> <category>control</category>

<body package="Gammanym" selector="step:">step: t 
	self thePractices do: [:r | r resetAttributes].
	self theDoctors do: [:d | d goToPractice].
	self theDoctors do: [:d | d goToHospital].
	self theConferenceCentres do: [:c | c updateConferenceTime: t].
	self theDoctors do: [:gc | gc goToConference].
	self theLabs do: [:a | a calculAdoption].
	self theLabs do: [:dm | dm sendDetailman].
	self theLabs do: [:f | f sendFlyers].
	self theLabs do: [:f | f sendJournals: t].
	self theDoctors do: [:i | i getInfoFromLab].
	self theDoctors do: [:i | i discussWithOccupants].
	self theDoctors do: [:i | i discussWithFriends: self theDoctors].
	self theDoctors do: [:u | u updateReadiness].
	self theDoctors do: [:u | u adoptDrug].
	self theConferenceCentres do: [:u | u updateAttendance: t].
	self theDoctors do: [:u | u resetAttributes].
	self exportMatrixColleagues.
	self exportMatrixFriends.
	self exportAdoption.
	self theCells do: 
			[:r | 
			r
				defineVisualState;
				show].
	t = 68 ifTrue: [self journalRelease].
	self updateData: t</body>
</methods>

<methods>
<class-id>CormasNS.Models.Gammanym.Gammanym</class-id> <category>accessing</category>

<body package="Gammanym" selector="simulation">simulation
	"Getter accessor without default value "
	^simulation</body>

<body package="Gammanym" selector="simulation:">simulation: anObject 
	simulation := anObject</body>

<body package="Gammanym" selector="theCells">theCells
^theCells</body>

<body package="Gammanym" selector="theCells:">theCells: x
theCells := x</body>

<body package="Gammanym" selector="theConferenceCentres">theConferenceCentres
^theConferenceCentres</body>

<body package="Gammanym" selector="theConferenceCentres:">theConferenceCentres: x
theConferenceCentres := x</body>

<body package="Gammanym" selector="theDoctors">theDoctors
^theDoctors</body>

<body package="Gammanym" selector="theDoctors:">theDoctors: x
theDoctors := x</body>

<body package="Gammanym" selector="theHospitals">theHospitals
^theHospitals</body>

<body package="Gammanym" selector="theHospitals:">theHospitals: x
theHospitals := x</body>

<body package="Gammanym" selector="theLabs">theLabs
^theLabs</body>

<body package="Gammanym" selector="theLabs:">theLabs: x
theLabs := x</body>

<body package="Gammanym" selector="thePractices">thePractices
^thePractices</body>

<body package="Gammanym" selector="thePractices:">thePractices: x
thePractices := x</body>
</methods>

<methods>
<class-id>CormasNS.Models.Gammanym.Gammanym</class-id> <category>shortcut</category>

<body package="Gammanym" selector="centres">centres
	^self thePractices select: [:c | c practiceType = #centre]</body>

<body package="Gammanym" selector="clinics">clinics
	^self thePractices select: [:c | c practiceType = #clinic]</body>

<body package="Gammanym" selector="privates">privates
	^self thePractices select: [:c | c practiceType = #private]</body>
</methods>

<methods>
<class-id>CormasNS.Models.Gammanym.Gammanym</class-id> <category>probes</category>

<body package="Gammanym" selector="adoption">adoption
	"return the data (a number) to be recorded"

	^(self theDoctors select: [:a | a drugAdoption = true]) size</body>

<body package="Gammanym" selector="adoptionIntegrated">adoptionIntegrated
	"return the data (a number) to be recorded"
	^(self theDoctors 
		select: [:c | c myPractice practiceType = #clinic and: [c drugAdoption = true]]) 
			size</body>

<body package="Gammanym" selector="adoptionIsolate">adoptionIsolate
	"return the data (a number) to be recorded"
	^(self theDoctors 
		select: [:c | c myPractice practiceType = #private and: [c drugAdoption = true]]) 
			size</body>
</methods>

<methods>
<class-id>CormasNS.Models.Gammanym.Gammanym</class-id> <category>matrix</category>

<body package="Gammanym" selector="exportAdoption">exportAdoption
	| aLine nameFile file |
	aLine := (Array new: 99 withAll: 'false') asOrderedCollection.
	self theDoctors 
		do: [:d | d drugAdoption ifTrue: [aLine at: d id put: d drugAdoption printString]].
	nameFile := 'adoption' , '.csv'.
	file := ((Cormas dataPath: self class name) asString,'\', self simulation, '\',nameFile) asFilename 	appendStream.
	aLine do: [:a | file nextPutAll: a , ','].
	file nextPutAll: '\' withCRs.
	file close</body>

<body package="Gammanym" selector="exportMatrixColleagues">exportMatrixColleagues
| aLine allLines nameFile file index |
	allLines := OrderedCollection new.
	self theDoctors do: 
			[:d | 
			aLine := (Array new: 99 withAll: 0) asOrderedCollection.
			(1 to: d dicoContacts size) do: 
					[:i | 
					aLine at: (d dicoContacts keys asOrderedCollection at: i)
						put: (d dicoContacts values asOrderedCollection at: i)].
			allLines addAll: aLine].
	nameFile := 'colleagues' , self timeStep printString , '.csv'.
file := ((Cormas dataPath: self class name) asString,'\', self simulation,'\',nameFile) asFilename 	appendStream.
	
	index := 1.
	allLines do: 
			[:a | 
			index = allLines size 
				ifFalse: [file nextPutAll: a printString , ',']
				ifTrue: [file nextPutAll: a printString].
			index \\ 99 = 0 ifTrue: [file nextPutAll: '\' withCRs].
			index := index + 1].
	file nextPutAll: '\' withCRs.
	file close</body>

<body package="Gammanym" selector="exportMatrixFriends">exportMatrixFriends
| aLine allLines nameFile file index |
	allLines := OrderedCollection new.
	self theDoctors do: 
			[:d | 
			aLine := (Array new: 99 withAll: 0) asOrderedCollection.
			(1 to: d dicoFriends size) do: 
					[:i | 
					aLine at: (d dicoFriends keys asOrderedCollection at: i)
						put: (d dicoFriends values asOrderedCollection at: i)].
			allLines addAll: aLine].
	nameFile := 'friends' , self timeStep printString , '.csv'.
file := ((Cormas dataPath: self class name) asString,'\', self simulation,'\',nameFile) asFilename 	appendStream.
	
	index := 1.
	allLines do: 
			[:a | 
			index = allLines size 
				ifFalse: [file nextPutAll: a printString , ',']
				ifTrue: [file nextPutAll: a printString].
			index \\ 99 = 0 ifTrue: [file nextPutAll: '\' withCRs].
			index := index + 1].
	file nextPutAll: '\' withCRs.
	file close</body>
</methods>

<methods>
<class-id>CormasNS.Models.Gammanym.Gammanym</class-id> <category>interface</category>

<body package="Gammanym" selector="inputLab">inputLab
	| interface |
	interface := InputLab new.
	interface numberOfDetailman value: 1.
	interface numberOfJournal value: 2.
	interface open.
	self theLabs add: Lab new init.
	self theLabs do: 
			[:d | 
			d detailman: interface numberOfDetailman value.
			d maxArticlesJournal: interface numberOfJournal value]</body>

<body package="Gammanym" selector="inputWithTwoColleagues">inputWithTwoColleagues
	| doctor adopters centre |
	centre := self theDoctors 
				select: [:c | c myPractice practiceType = #centre].
	adopters := Dialog 
				request: ' Moderately integrated innovators ( must be &lt;= ' 
						, centre size printString , ')'
				initialAnswer: ' 0'.
	adopters asNumber timesRepeat: 
			[doctor := Cormas selectRandomlyFrom: centre.
			doctor drugAdoption: true.
			doctor readiness: 0.
			centre remove: doctor]</body>

<body package="Gammanym" selector="journalRelease">journalRelease
	| interface string |
	interface := JournalRelease new.
	string := String new.
	self theLabs first journalRelease 
		do: [:e | string := string , e printString , ' '].
	interface journalDate value: string.
	interface open</body>
</methods>



</st-source>
